<script>
import Layout from "../../Layouts/Layout.vue";
import CourseContent from "../../Components/CourseContent.vue";
import {Head, Link} from "@inertiajs/vue3";
import {computed} from "vue";
import PrimaryButton from "../../Components/PrimaryButton.vue";

export default {
  components: {PrimaryButton, Head, Link, CourseContent},

  layout: Layout,

  props: {
    lesson: {
      type: Object,
    },
    isRead: {
      type: Boolean,
    },
  },

  setup(props) {
    const linkHref = computed(() => `/lessons/${props.lesson.id}`);

    const lessonTitle = computed(() => `${props.lesson.serial_number} ${props.lesson.name}`);

    const completeBtnText = computed(() => props.isRead ? 'Вы уже прочитали этот курс!' : 'Я прочитал урок');

    return {
      linkHref,
      lessonTitle,
      lessonCompleteBtnText: completeBtnText,
    };
  }
}

</script>

<template>
  <Head :title="lessonTitle"></Head>

  <section id="slide-code">
    <div class="main-banner-area parallax">
      <div class="container">
        <div class="main-banner-content block">
          <h1 data-aos="fade-left">
            <span>{{ lessonTitle }}</span>
          </h1>
        </div>
      </div>
    </div>
  </section>
  <section id="article">
    <div class="container">
      <div class="article__content">
        <p>В данном учебном курсе мы будем писать программы без графического пользовательского интерфейса, то есть без кнопок, текстовых полей ввода и
          т. д. Программы будут принимать на вход данные от пользователя с клавиатуры (а чуть позже мы научимся работать с файловым вводом и выводом),
          а выводить результат будут на экран. Всё взаимодействие с программой будет происходить в командной строке, также называемой консолью или терминалом.</p>
        <p>Во введении к курсу мы узнали, что командная строка в среде разработки Visual Studio Code находится внизу на вкладке «Терминал». Именно в ней мы будем
          вводить данные с клавиатуры, а программа будет выводить результаты. Как было сказано ранее, мы будем писать компьютерные программы, которые принимают на
          вход данные, работают с ними и выводят результат на экран.</p>
        <p>Вспомним программу из введения:</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>
                        (<span class="hljs-string">"Привет, мир!"</span>)
                    </code>
                </pre>
        <p>В этой программе мы вызываем встроенную функцию под названием <code>print()</code>. Как она устроена внутри, нам пока не столь важно. Главное — запомнить,
          что у неё есть имя, по которому к ней можно обратиться, плюс она принимает данные и обрабатывает их. О том, какими могут быть данные, мы тоже поговорим позже
          — в нашем примере мы передаём строку «Привет, мир!».</p>
        <p>В Python строки заключены в кавычки — можно использовать одинарные, двойные и тройные (рекомендуется
          их составлять из трёх двойных). Внутри кавычек одного вида можно использовать другой вид кавычек как часть выводимой на экран строки.</p>
        <p>Например:</p>
        <ul>
          <li>
            <code>print('Привет, мир!')</code>
          </li>
          <li>
            <code>print("Привет, мир!")</code>
          </li>
          <li>
            <code>print("""Привет, мир!""")</code>
          </li>
          <li>
            <code>print("Программа выводит фразу 'Привет, мир!'")</code>
          </li>
        </ul>
        <p>Данные в программу могут поступать различными способами. Самый простой и привычный для пользователя — это ввод с клавиатуры. Для этого в Python
          используется функция <code>input()</code>, которая возвращает в программу введённую пользователем строку. Но данные нужно куда-то сохранить, и в
          этом нам помогают переменные. Переменным назначаются имена, в них записываются значения, и затем они используются в программе по мере необходимости.</p>
        <p>Напишем программу, которая получает от пользователя строку и выводит на экран:</p>
        <pre class="hljs">
                    <code>phrase = <span class="hljs-built_in">input</span>()
                        <span class="hljs-built_in">print</span>(phrase)
                    </code>
                </pre>
        <p>После запуска программы происходит приостановка выполнения и в терминале появляется приглашение для ввода данных:</p>
        <p><img src="https://yastatic.net/s3/ml-handbook/admin/1_1_ccbffce74e.png" alt="1_1.png"></p>
        <p>После ввода данных необходимо нажать клавишу <code>Enter</code>. Программа запишет введённые данные в переменную <code>phrase</code> и продолжит
          выполнение со следующей строчки. Переменная начинает существовать в программе, когда в неё записывается какое-то значение. В момент записи значения
          переменной назначается тип данных, определённый в соответствии со значением.</p>
        <p>В нашем примере в переменную <code>phrase</code> записывается строка, введённая пользователем. Поэтому переменной <code>phrase</code> назначается
          встроенный в язык Python тип данных <code>str</code>. Тип данных <code>str</code> используется для хранения строк, а сами строки являются
          упорядоченной последовательностью символов.</p>
        <p>У функции <code>input()</code> можно задать параметр-строку перед вводом значения — и тогда указанный текст будет сопровождать приглашение к
          вводу данных:</p>
        <pre class="hljs">
                    <code>phrase = <span class="hljs-built_in">input</span>(<span class="hljs-string">"Введите строку: "</span>)
                        <span class="hljs-built_in">print</span>(phrase)
                    </code>
                </pre>
        <p><img src="https://yastatic.net/s3/ml-handbook/admin/1_2_91d62f8f9d.png" alt="1_2.png"></p>
        <p>Для именования переменных и правильного оформления кода существует стандарт <a href="https://peps.python.org/pep-0008/">PEP 8</a>
          (Python Enhancement Proposals), который следует соблюдать. Согласно стандарту PEP 8, имена переменных должны содержать маленькие буквы
          английского алфавита и символ «подчёркивание» для разделения слов в имени. Пример имён переменных по стандарту: value, first_value.</p>
        <p>Нельзя использовать следующие однобуквенные имена переменных:</p>
        <ul>
          <li>I (большая английская i);</li>
          <li>l (маленькая английская L);</li>
          <li>O.</li>
        </ul>
        <p>Эти однобуквенные имена усложнят читаемость кода, так как могут быть перепутаны между собой или с цифрами. Все стандарты PEP можно посмотреть
          на <a href="https://peps.python.org/">этой странице</a>.</p>
        <p>Но вернёмся к функции <code>print()</code>. С её помощью можно выводить сразу несколько значений. Для этого их нужно перечислить через
          запятую. Выведем, например, фразу <code>Добрый день, %имя%.</code>:</p>
        <pre class="hljs">
                    <code>name = <span class="hljs-string">"Пользователь"</span>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"Добрый день,"</span>, name, <span class="hljs-string">"."</span>)
                    </code>
                </pre>
        <p>В консоли отобразится:</p>
        <pre>Добрый день, Пользователь .</pre>
        <p>Как видим, результат работы программы не соответствует нашим ожиданиям, так как между словом «Пользователь» и точкой появился пробел. Данный
          пробел является символом, который по умолчанию ставится между выводимыми значениями. Вместо пробела можно указать любую другую строку, даже
          пустую. Для этого нужно передать в функцию <code>print()</code> <em>именованный аргумент</em> <code>sep</code> (англ. separator — «разделитель»).
          Обратите внимание: для именованных аргументов вокруг символа "=" не ставятся пробелы. Сделаем так, чтобы вместо пробела в качестве разделителя
          использовалась пустая строка:</p>
        <pre class="hljs">
                    <code>name = <span class="hljs-string">"Пользователь"</span>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"Добрый день, "</span>, name, <span class="hljs-string">"."</span>, sep=<span class="hljs-string">""</span>)
                    </code>
                </pre>
        <p>В консоли отобразится:</p>
        <pre>Добрый день, Пользователь.</pre>
        <p>Но в таком случае необходимые пробелы нам придётся ставить самим, а это неудобно. К счастью, в Python существует удобный и мощный инструмент
          для форматирования строк — <em>f-строки</em>. Чтобы задать f-строку, необходимо поставить букву f перед открывающей кавычкой строки. Далее
          f-строка записывается как единое целое, с учётом правил её форматирования, и закрывается соответствующей кавычкой:</p>
        <pre class="hljs">
                    <code>name = <span class="hljs-string">"Пользователь"</span>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">f"Добрый день, <span class="hljs-subst">{name}</span>."</span>)
                    </code>
                </pre>
        <p>f-строки также можно использовать для выравнивания строк. Например, если требуется добавить символы "0" слева (для выравнивания по правому
          краю), справа (для выравнивания по левому краю) или слева и справа (для выравнивания посередине) от исходной строки до достижения длины в 9
          символов:</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">f"<span class="hljs-subst">{<span class="hljs-number">123</span>:<span class="hljs-number">0</span>&gt;<span class="hljs-number">9</span>}</span>"</span>)
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">f"<span class="hljs-subst">{<span class="hljs-number">123</span>:<span class="hljs-number">0</span>&lt;<span class="hljs-number">9</span>}</span>"</span>)
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">f"<span class="hljs-subst">{<span class="hljs-number">123</span>:<span class="hljs-number">0</span>^<span class="hljs-number">9</span>}</span>"</span>)
                    </code>
                </pre>
        <p>В консоли будут напечатаны следующие строки:</p>
        <pre>
                    000000123
                    123000000
                    000123000
                </pre>
        <p>Внутри f-строк можно обращаться к переменным, используя фигурные скобки, как в примере выше, а также производить операции, выполнять функции
          и подставлять их результаты в данную строку. И это только малая часть возможностей f-строк. Более подробно про них можно почитать в данном
          <a href="https://docs.python.org/3/tutorial/inputoutput.html#formatted-string-literals">источнике</a>.</p>
        <p>Использование f-строк является приоритетным способом форматирования. Наряду с f-строками существует функция <code>format()</code>,
          которая также предназначена для удобного форматирования (мы рассмотрим её чуть позже). Также форматирование строк может производиться с помощью
          символа <code>%</code>. Однако данный способ форматирования является устаревшим
          (<a href="https://docs.python.org/3/tutorial/inputoutput.html#old-string-formatting">здесь</a> можно почитать про него подробнее).</p>
        <p>В строках можно применять управляющие символы, начинающиеся с символа «бэкслеш» <code>\</code>. Например:</p>
        <ul>
          <li>
            <code>\n</code> — переход на новую строку;
          </li>
          <li>
            <code>\t</code> — табуляция;
          </li>
          <li>
            <code>\r</code> — возврат каретки в начало строки;
          </li>
          <li>
            <code>\b</code> — возврат каретки на один символ.
          </li>
        </ul>
        <p>Кроме того, с помощью бэкслеша можно экранировать символы, то есть делать их частью выводимой строки. Например, для вывода символа
          <code>\</code> необходимо его экранировать самим собой:</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"\\"</span>)
                    </code>
                </pre>
        <p>Подробнее об экранировании можно почитать в
          <a href="https://docs.python.org/3/reference/lexical_analysis.html#string-and-bytes-literals">этом источнике</a>.</p>
        <p>В функции <code>print()</code> кроме параметра <code>sep</code> существует параметр <code>end</code>, который определяет символ в конце
          строки. Значение по умолчанию для него — переход на новую строку, обозначаемый как <code>\n</code>. Если вывести строки с помощью нескольких
          использований функции <code>print()</code>, то вывод каждой из них будет осуществлён с новой строки:</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"Привет, Пользователь!"</span>)
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"Как дела?"</span>)
                    </code>
                </pre>
        <pre>Привет, Пользователь! Как дела?</pre>
        <p>Над строками можно производить следующие операции:</p>
        <ul>
          <li>сложение (конкатенация строк);</li>
          <li>умножение строки на целое число.</li>
        </ul>
        <p>Результатом сложения строк будет новая строка, представляющая собой записанные последовательно складываемые строки (строки как бы склеиваются
          друг с другом, образуя новую строку).</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"Сложно"</span> + <span class="hljs-string">"подчинённый"</span>)
                    </code>
                </pre>
        <pre>Сложноподчинённый</pre>
        <p>При умножении строки на целое число <code>n</code> получается новая строка, состоящая из <code>n</code> дублирований исходной строки.
          Например, выведем 10 символов <code>-</code> подряд:</p>
        <pre class="hljs">
                    <code>
                        <span class="hljs-built_in">print</span>(<span class="hljs-string">"-"</span> * <span class="hljs-number">10</span>)
                    </code>
                </pre>
        <p>В одном из следующих параграфов мы познакомимся с другими возможностями Python по работе со строками. А сейчас перейдём к работе с числами.
          Для создания целочисленной переменной в программе достаточно назначить ей имя и присвоить целочисленное значение. Например:</p>
        <pre class="hljs">
                    <code>
                        n = <span class="hljs-number">10</span>
                    </code>
                </pre>
        <p>По аналогии создаются вещественные числовые переменные, только в качестве разделителя целой и дробной частей используется десятичный
          разделитель «точка»:</p>
        <pre class="hljs">
                    <code>
                        pi = <span class="hljs-number">3.14</span>
                    </code>
                </pre>
        <p>Для преобразования строк в числа и наоборот используются следующие функции:</p>
        <ul>
          <li>
            <code>int()</code> — преобразует строку (или вещественное число) в целое число. Дополнительно можно указать, в какой системе счисления
            было записано исходное число. По умолчанию используется десятичная система. При конвертации вещественного числа в целое отбрасывается
            дробная часть;</li>
          <li>
            <code>float()</code> — преобразует строку (или целое число) в вещественное число;
          </li>
          <li>
            <code>str()</code> — преобразует значения (в общем случае не только числовые) в строки.
          </li>
        </ul>
      </div>

      <hr>
      <Link
        :href="linkHref"
        method="put"
        :disabled="isRead"
        preserve-state
        preserve-scroll
        as="button"
      >
        {{ lessonCompleteBtnText }}
      </Link>

      <div class="check-code">
        <Link href="/practice">Потренируемся?</Link>
      </div>
    </div>
  </section>

  <CourseContent />
</template>
